require "spec_helper"
describe "cmis client", :contract => true do
  before(:each) do
    @sut = Grapefruit::CmisClient.new(ENV["CMIS_HOST"], ENV["CMIS_USER"], ENV["CMIS_PASS"])
  end

  context "Tickets" do
    it "should get a ticket on instantiation" do
      expect(@sut.ticket).to be
    end

    it "should get a valid ticket" do
      expect(@sut.ticket).to match(/TICKET_[0-9a-f]+/)
    end

    it "should not try to retrieve another ticket if it already has one" do
      current_ticket = @sut.ticket
      expect(@sut.ticket).to eq(current_ticket)
    end
  end

  it "should be able to get the repository" do
    expect(@sut.repository).to be_true
  end

  it "Verify root folder exists" do
     expect(@sut.root).to be_true
  end

  it "Verify repository has sites" do
     expect(@sut.sites).to be_true
  end

  context "Creating Folders" do
    it "should make a request to the CMIS host to create a folder" do
      sut = Grapefruit::CmisClient.new(ENV["CMIS_HOST"], ENV["CMIS_USER"], ENV["CMIS_PASS"])
      folder = sut.create_folder(FakeFolder.new)
      expect(folder.cmis_object_id).to be
    end
    it "should be able to create a folder under another given folder" do
      pending "Not Yet Implemented"
    end
    it "should optionally behave like mkdir -p" do
      pending "Not Yet"
    end
    it "should not try to create folders that already exist" do
      pending "Not Yet"
    end
  end



end
